;  A 16-bit DOS HelloWorld program originally by RedOx.  Produces a small model .EXE executable.

; To assemble and link from within WinAsm Studio, you must have a special 16-bit linker, 
; such as the one in the archive at this URL- http://win32assembly.online.fr/files/Lnk563.exe
; Run the archive to unpack Link.exe, rename the Link.exe file to Link16.exe and copy it
; into the \masm32\bin folder.

.386		
option	segment:use16

del_x	equ 	0823Ch
del_y	equ	0823Eh
box_bot_y	equ	08238h
box_top_y	equ	08230h
box_right_x	equ	08234h
box_left_x	equ	0822Ch
vel_y	equ	08242h
vel_x	equ	08240h
map_width	equ	06C08h
tile_data_1	equ	06C48h


dseg		segment	para public 'data'
dseg		ends



cseg	segment	para public use16  'code'
	assume	cs:cseg, ds:dseg

MOVE_VERT:

mov 	ax, ds:[del_y]		;bx = del_y
cwde
mov	ebx, eax

mov	eax, ds:[box_top_y]	            	;box_top_y -= del_y
add	eax, ebx                        	;bp-8 = TILE(box_top_y)
mov	ds:[box_top_y], eax                
shr	eax, 12
mov	ss:[bp-8], ax

mov 	eax, ds:[box_bot_y]		;box_bot_y -= del_y            	
add 	eax, ebx                        	;bp-10 = TILE(box_bot_y)
mov 	ds:[box_bot_y], eax                
shr	eax, 12
mov	ss:[bp-10], ax	
                                        
mov	eax, ds:[box_left_x]	       	;bp-4 = TILE(box_left_x)	
shr	eax, 12			                
mov	ss:[bp - 4], ax                    

mov	eax, ds:[box_right_x]		;bp-6 = TILE(box_right_x)              
shr	eax, 12                         
mov	ss:[bp - 6], ax                                           

cmp 	bx, 0				            
je	MOVE_HORZ		;if del_y = 0, goto MOVE_HORZ                
jl	MOVE_UP		;if del_y<0, goto MOVE_UP			

;-----------------------------------------------
MOVE_DOWN:
mov	eax, ds:[box_bot_y]		;eax = TILE(box_bot_y - del_y)
sub	eax, ebx
shr	eax, 12
cmp	word ptr ax, ss:[bp-10]            	;if(TILE(box_bot_y - del_y) = TILE(box_bot_y))
je	MOVE_HORZ		;goto MOVE_HORZ

mov	cx, ss:[bp-4]									
CHECK_TILE_DOWN:		;for (cx = TILE(box_left_x); cx < = TILE(box_right_x); cx++)
cmp	cx, ss:[bp - 6]					
jg	MOVE_HORZ 	

mov	ax, ss:[bp-10]		
imul	ax, ds:[map_width]		;ax = (TILE(box_bot_y) * mapwidth) 	
add	ax, cx		;ax = tile sprite has crossed into			
shl	ax, 1		;convert to word			
les	bx, ds:[tile_data_1]		;point es:bx to tile_data	
add	bx, ax		;point es:bx to tile specified by ax					
mov	bx, es:[bx]		;load bx with tile_number for tile specified by ax		
shl	bx, 1		;convert to word

cmp	word ptr [bx + 0A34h], 0	;0A34h = tile_info blocking up plane; 0 = fall through	
je	UPDATE_COUNTER_DOWN	;if fall_through, skip position correction
mov	word ptr ds:[vel_y], 0		;else correct position

mov	eax, ds:[box_bot_y]				
inc	eax
and	eax, 0FFFh

sub	ds:[del_y], eax					
sub	ds:[box_top_y], eax
sub	ds:[box_bot_y], eax


mov	word ptr ss:[bp - 12], 2					
jmp	MOVE_HORZ

UPDATE_COUNTER_DOWN:
inc	cx								
jmp	CHECK_TILE_DOWN					

;---------------------------------
MOVE_UP:
mov	eax, ds:[box_top_y]		;eax = TILE(box_top_y - del_y)
sub	eax, ebx
shr	eax, 12
cmp	word ptr ax, ss:[bp-8]            	;if(TILE(box_top_y - del_y) = TILE(box_top_y))
je	MOVE_HORZ		;goto MOVE_HORZ

mov	cx, ss:[bp-4]									
CHECK_TILE_UP:			;for (cx = TILE(box_left_x); cx <= TILE(box_right_x); cx++)
cmp	cx, ss:[bp - 6]					
jg	MOVE_HORZ 	

mov	ax, ss:[bp-8]		
imul	ax, ds:[map_width]		;ax = (TILE(box_top_y) * mapwidth) 	
add	ax, cx		;ax = tile sprite has crossed into			
shl	ax, 1		;convert to word			
les	bx, ds:[tile_data_1]		;point es:bx to tile_data	
add	bx, ax		;point es:bx to tile specified by ax					
mov	bx, es:[bx]		;load bx with tile_number for tile specified by ax		
shl	bx, 1		;convert to word

cmp	word ptr [bx + 13C0h], 0	;13C0h = tile_info blocking down plane; 0 = move through	
je	UPDATE_COUNTER_UP	;if move through, skip position correction
mov	word ptr ds:[vel_y], 0		;else correct position

mov	eax, ds:[box_top_y]				
and	eax, 0FFFh						
neg	eax
add	eax, 1000h

add	ds:[del_y], ax					
add	ds:[box_top_y], eax
add	ds:[box_bot_y], eax

mov	word ptr ss:[bp - 12], 8					
jmp	MOVE_HORZ

UPDATE_COUNTER_UP:
inc	cx								
jmp	CHECK_TILE_UP					

;----------------------------------------
MOVE_HORZ:
mov 	ax, ds:[del_x]		;bx = del_x
cwde
mov	ebx, eax

mov	eax, ds:[box_left_x]	            	;box_left_x -= del_x
add	eax, ebx                        	;bp-8 = TILE(box_left_x)
mov	ds:[box_left_x], eax                
shr	eax, 12
mov	ss:[bp-8], ax

mov 	eax, ds:[box_right_x]		;box_right_x -= del_x            	
add 	eax, ebx                        	;bp-10 = TILE(box_right_x)
mov 	ds:[box_right_x], eax                
shr	eax, 12
mov	ss:[bp-10], ax	
                                        
mov	eax, ds:[box_top_y]	       	;bp-4 = TILE(box_top_y)	
shr	eax, 12			                
mov	ss:[bp - 4], ax                    

mov	eax, ds:[box_bot_y]		;bp-6 = TILE(box_bot_y)              
shr	eax, 12                         
mov	ss:[bp - 6], ax                                           

cmp 	bx, 0				            
je	MOVE_END		;if del_x = 0, goto MOVE_END               
jl	MOVE_LEFT		;if del_x<0, goto MOVE_LEFT			
	

;----------------------------------------
MOVE_RIGHT:
mov	eax, ds:[box_right_x]		;eax = TILE(box_right_y - del_x)
sub	eax, ebx
shr	eax, 12
cmp	word ptr ax, ss:[bp-10]            	;if(TILE(box_right_x - del_x) == TILE(box_right_x))
je	MOVE_END		;goto MOVE_END


mov	cx, ss:[bp-4]					
CHECK_TILE_RIGHT:		;for (cx = TILE(box_top_y); cx <= TILE(box_bot_y); cx++)
cmp	cx, ss:[bp - 6]					
jg	MOVE_END 		

mov	ax, cx 		
imul	ax, ds:[map_width]		;ax = (cx * mapwidth)
add	ax, ss:[bp-10]		;ax += TILE(box_right_x)
shl	ax, 1		;convert to word					
les	bx, ds:[tile_data_1]		;point es:bx to tile_data		
add	bx, ax		;point es:bx to tile specified by ax					
mov	bx, es:[bx]		;load bx with tile_number for tile specified by ax				
shl	bx, 1		;convert to word					

cmp	word ptr ds:[bx + 1886h], 0	;ds:1886 = tile blocking left plane; 0 = move through		
je	UPDATE_COUNTER_RIGHT	;if blocking, correct position
mov	word ptr ds:[vel_x], 0						

mov	eax, ds:[box_right_x]				
inc	eax										
and	eax, 0FFFh						

sub	ds:[del_x], eax					
sub	ds:[box_right_x], eax
sub	ds:[box_left_x], eax

or	word ptr ss:[bp - 12], 4	;add 4 to return					
jmp	MOVE_END

UPDATE_COUNTER_RIGHT:
inc	cx								
jmp	CHECK_TILE_RIGHT				

;----------------------------------------
MOVE_LEFT:
mov	eax, ds:[box_left_x]		;eax = TILE(box_left_x - del_x)
sub	eax, ebx
shr	eax, 12
cmp	word ptr ax, ss:[bp-8]            	;if(TILE(box_left_x - del_x) == TILE(box_left_x))
je	MOVE_END		;goto MOVE_END


mov	cx, ss:[bp-4]		;for (cx = TILE(box_top_y); cx <= TILE(box_bot_y); cx++)				
CHECK_TILE_LEFT:
cmp	cx, ss:[bp - 6]					
jg	MOVE_END 	

mov	ax, cx 		
imul	ax, ds:[map_width]		;ax = (cx * mapwidth)
add	ax, ss:[bp-8]		;ax += TILE(box_left_x)
shl	ax, 1		;convert to word					
les	bx, ds:[tile_data_1]		;point es:bx to tile_data		
add	bx, ax		;point es:bx to tile specified by ax					
mov	bx, es:[bx]		;load bx with tile_number for tile specified by ax				
shl	bx, 1		;convert to word					

cmp	word ptr ds:[bx + 0EFAh], 0	;ds:0EFAh = tile blocking left plane; 0 = move through		
je	UPDATE_COUNTER_LEFT	;if blocking, correct position
mov	word ptr ds:[vel_x], 0						

mov	eax, ds:[box_left_x]				
and	eax, 0FFFh						
neg	eax
add	eax, 1000h

add	ds:[del_x], ax					
add	ds:[box_right_x], eax
add	ds:[box_left_x], eax

or	word ptr ss:[bp - 12], 1	;add 1 to return					
jmp	MOVE_END

UPDATE_COUNTER_LEFT:
inc	cx								
jmp	CHECK_TILE_LEFT													

;----------------------------------------
MOVE_END:
mov	ax, ss:[bp-12]
pop 	di
pop 	si
mov 	sp, bp
pop	bp
RET	
cseg	ends

end